"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const gen = require("../main");
const utils = require("../utils");
function adapter(dsl, formatOptions, importer, currentPath) {
    return __awaiter(this, void 0, void 0, function* () {
        const training = { data: [] };
        const testing = { data: [] };
        if (formatOptions) {
            utils.mergeDeep(training, formatOptions);
        }
        const utteranceWriter = (utterance, intentKey, isTrainingExample) => {
            const example = utterance.reduce((acc, next) => {
                if (next.type === 'Slot' && next.slot) {
                    acc.entityLabels.push({
                        endCharIndex: acc.text.length + next.value.length,
                        entityName: next.slot,
                        startCharIndex: acc.text.length
                    });
                }
                acc.text += next.value;
                return acc;
            }, { text: '', intentName: intentKey, entityLabels: [] });
            if (isTrainingExample) {
                training.data.push(example);
            }
            else {
                testing.data.push(example);
            }
        };
        yield gen.datasetFromString(dsl, utteranceWriter, importer, currentPath);
        return { training, testing };
    });
}
exports.adapter = adapter;
